char c1, c2;

#define FPB_FREQUENCY   (4000000*20)

#define OUTPUT  0
#define INPUT   1

#define DE_TRIS TRISGbits.TRISG6
#define DE_LAT  LATGbits.LATG6
#define DE_ON   DE_LAT = 1
#define DE_OFF  DE_LAT = 0
#define RE_TRIS TRISFbits.TRISF0
#define RE_LAT  LATFbits.LATF0
#define RE_ON   RE_LAT = 0
#define RE_OFF  RE_LAT = 1

void UART2_Init (unsigned long int BaudRate)
{
  U2BRG = ((FPB_FREQUENCY/BaudRate)/16)-1;
  U2STAbits.UTXEN = 1;
  U2STAbits.URXEN = 1;
  U2MODEbits.ON = 1;
}

void UART2_Transmit (char Data)
{
  while (U2STAbits.UTXBF);
  U2TXREG = Data;
}

char UART2_Receive (void)
{
  if (U2STAbits.URXDA)
    return U2RXREG;
  else
    return 0;
}

void setup ()
{
  RE_TRIS = OUTPUT;
  DE_TRIS = OUTPUT;
  RE_ON;
  DE_OFF;

  Serial.begin (115200);
  UART2_Init (115200);
}

void loop ()
{
  c1 = Serial.read ();
  if (c1!=-1)
  {
    DE_ON;
    UART2_Transmit (c1);
    delay(10);
    DE_OFF;
  }

  c2 = UART2_Receive ();
  if (c2)
    Serial.print (c2);
}


